// Note the Driver mentioned in the article that maps USB GPS units into
// Windows 8 format is included in this download

main:
   call InitSensors(0,0,0,0)
   call ReadGPS(Long,Lat)
   xyString 10,100,"Longitude: ",Long;" "
   xyString 10,120,"Latitude:  ",Lat;" "
end

sub ReadGPS(&a,&b)
   // give the Interface Utility a command
   setcbtext("GPS") 
   // now request the Utility to perform 
   filerename ("RBsTurn.txt","SensorsTurn.txt")
   // and wait for it to respond
   while !fileexists("RBsTurn.txt") 
   wend
   // then get the data from the clipboard
   
   s=getcbtext()
   // and parse it
   delay 100
   mfromstring Sensors,s,"," 
   // and return the values as variables
   b=Sensors[1]
   a=Sensors[2]
   // round to 5 decimal places
   a= Round(a*100000)/100000.0
   b= Round(b*100000)/100000.0
return  

sub InitSensors(a,b,c,d)
  // The Utility MUST reside in the same directory as
  // the application unless you set up paths 
  print "Initializing..."
  SetCBtext("stop") // stop utility if running
  filerename ("RBsTurn.txt","SensorsTurn.txt")
  delay 100
  Spawn ("RBsensorUtility.exe","",P_NOWAIT) 
  // provide time for Utility to spawn
  delay 1000 
  ClearScr   
  //  The above code can be eliminated if you always
  //  start the Utility manually. We have code in
  //  the utility that SHOULD prevent a second copy
  //  from running - but for some unknown reason it
  //  is not 100% reliable.  The above code seems to
  //  always work on our machine.
  dim Sensors[28] //max available from utility
  dim Offsets[4]                 
  for i=0 to 27
    Sensors[i]=""
  next
  // allow setting certain angles to zero
  Offsets[0]=a
  Offsets[1]=b
  Offsets[2]=c
  Offsets[3]=d 
  // note: new initialization will be added here for voice commands 
return  

sub Orientation(&t1,&t2,&t3,&h)
   // Request readings
   SetCBtext("tilt")
   filerename ("RBsTurn.txt","SensorsTurn.txt")
   // and wait for it to respond
   while !fileexists("RBsTurn.txt") 
   wend
   delay 10
   // get the data
   s=getcbtext()
   // and parse it
   mfromstring Sensors,s,"," 
   t1 = round(Sensors[1])+Offsets[0]
   t2 = round(Sensors[2])+Offsets[1]
   t3 = round(Sensors[3])+Offsets[2]
   h  = round(Sensors[5])+Offsets[3]
   // ensure heading within normal range
   if h>359 then h-=360
   if h<0 then h+=360
return


